#include <memory.h>
#include <iostream>
#include <string>
using namespace std;

const int maxv = 2000;

int n, m;
const int infinity = 10000;

int f[maxv][maxv];
int c[maxv][maxv];

int flow[maxv];
int pr[maxv]; 
int cor[maxv];
int queue[maxv];
int qp, qc; 

int FindPath(int source, int target) 
{
        qp = 0; qc = 1; queue[0] = source;
        pr[target] = -1; 
        int i;
        int v;  
        memset(flow, 0, sizeof(int)*n); 
        flow[source] = infinity; 
        while (pr[target] == -1 && qp < qc)
        {
                v = queue[qp];
                for (i=0; i<n; i++)
                if ((c[v][i] - f[v][i])>0 && flow[i] == 0) 
                {
                        queue[qc] = i; qc++;
                        pr[i] = v;
                        if (c[v][i]-f[v][i] < flow[v])
                             flow[i] = c[v][i]-f[v][i];
                        else
                             flow[i] = flow[v];
                }
            qp++;
        }
        if (pr[target] == -1) return 0; 
        v = target;
        while (v != source)
        {
                f[pr[v]][v] +=flow[target];
                c[v][pr[v]] +=flow[target];
                cor[pr[v]]=v-(n-2)/2;
                v = pr[v];
        }
        return flow[target]; 
}

int MaxFlow(int source, int target) 
{
        memset(f, 0, sizeof(int)*maxv*maxv); 
        memset(cor, 0, sizeof(int)*maxv);
        int maxflow = 0; 
        int addflow;
        do
        {
                addflow = FindPath(source, target);
                maxflow += addflow;
        } while (addflow >0);
        return maxflow;
}

int main()
{
   int s, t;
   string w, v;
   cin>>n;
   cin>>w;
   memset(c,0, sizeof (int)*maxv*maxv);
   for (int i=0; i<n; i++){
       cin>>v;
       for (int j=0; j<6; j++)
           for (int k=0; k<n; k++){
               if (v[j]==w[k])c[k][n+i]=1;}}
   s=2*n;                        
   for (int i=0; i<n; i++)c[s][i]=1;     
   t=2*n+1;
   for (int i=0; i<n; i++)c[n+i][t]=1;  
   n+=n+2;    
   int k=(n-2)/2;
   if (MaxFlow(s, t)==k)
   {
       cout<<"YES"<<endl; 
       for (int i=0;i<k-1;i++)cout<<cor[i]+1<<' '; cout<<cor[k-1]+1<<endl;
   }    
   else cout<<"NO"<<endl;
  
   return 0;
}
